package com.beifan.foxlibc.framework.spring.enable;

import com.beifan.foxlibc.framework.spring.configuration.GlobalExceptionHandler;
import com.beifan.foxlibc.framework.spring.configuration.ValidationConfiguration;
import com.beifan.foxlibc.framework.spring.configuration.WebCorsConfiguration;
import com.beifan.foxlibc.framework.spring.service.jwt.AuthenticationServiceImplements;
import org.springframework.context.annotation.Import;

import java.lang.annotation.*;

/**
 * 启用邮箱
 *
 * @author lts
 * Create time 2022/4/22
 */
@Target({ElementType.TYPE})
@Retention(RetentionPolicy.RUNTIME)
@Import(value = {
        /* Jwt Token 生成 */
        AuthenticationServiceImplements.class,
        /* 参数校验配置 */
        ValidationConfiguration.class,
        /* 全局异常拦截 */
        GlobalExceptionHandler.class,
        /* 跨域配置 */
        WebCorsConfiguration.class
})
@Documented
public @interface EnableDevKit
{
}
