package com.beifan.foxlibc.framework.spring.service.jwt;

import java.util.Date;
import java.util.Map;

/**
 * 认证 JWT Token 生成
 * @author lts
 * Create time 2022/4/27
 */
@SuppressWarnings("UnusedReturnValue")
public interface AuthenticationService
{
    /** 预设算法, 在__CODEINT文件中配置 */
    void useEnv(String name);
    /** 获取当前的预设算法 */
    String getEnv(String token);
    /** 创建Token */
    String createToken(Map<String, Object> claims);
    /** 获取token内容 */
    <T> T claimsValue(String token, String key);
    /** 获取 token 过期时间 */
    Date getExpireTime(String token);
    /** 验证token */
    boolean validate(String token);
    /** 刷新token过期时间 */
    Date flushExpireTime(String token);
}
