package com.beifan.foxlibc.framework.spring.service.jwt;

import com.beifan.foxlibc.framework.utils.Assert;

/**
 * Jwt生成支持的算法
 *
 * @author lts
 * Create Time 2022/6/30
 */
public enum JwtAlgorithm {
    RS256,
    HS256,
    ES256;

    public static JwtAlgorithm forName(String name) {
        return Assert.throwIfError(() -> {
            return valueOf(name);
        }, "不支持的算法: {}", name);
    }
}
