package com.beifan.foxlibc.framework.utils;

import java.util.Collection;

/**
 * @author lts
 * Create Time 2022/7/1
 */
public class Assert {

    /**
     * 如果是空就抛出异常
     */
    public static void throwIfNull(Object object, String message, Object... args)
    {
        if (object == null)
            throw new NullPointerException(StringUtils.fmt(message, args));
    }

    /**
     * 抛出异常，根据bool变量判断
     */
    public static void throwIfBool(boolean bool, String message, Object... args)
    {
        if (!bool)
            throw new IllegalArgumentException(StringUtils.fmt(message, args));
    }

    /**
     * 如果集合为空，则抛出异常
     */
    public static void throwIfEmpty(Collection<?> collection, String message, Object... args)
    {
        throwIfBool(!collection.isEmpty(), message, args);
    }

    /**
     * 如果函数执行出错，则抛出异常(可以自定义异常信息)
     */
    public static <R> R throwIfError(CallbackFunctionMR0<R> call, String message, Object... args)
    {
        try {
            return call.apply();
        } catch (Throwable e) {
            throw new IllegalArgumentException(StringUtils.fmt(message, args), e);
        }
    }

}
