package com.beifan.foxlibc.framework.utils;

import com.beifan.foxlibc.framework.utils.collection.Lists;
import com.beifan.foxlibc.framework.utils.refection.ClassUtils;
import org.springframework.beans.BeanUtils;

import java.util.List;

/**
 * @author lts
 * Create time 2022/4/22
 */
public class BeanMaps
{

    /**
     * 拷贝属性到新的对象
     *
     * @param source 源对象
     * @param target 目标对象
     */
    public static <T> T copyProperties(Object source, Class<T> target)
    {
        T _target = ClassUtils.newInstance(target);
        BeanUtils.copyProperties(source, _target);
        return _target;
    }

    /**
     * 拷贝属性到新的对象
     *
     * @param source 源对象
     * @param target 目标对象
     */
    public static void copyProperties(Object source, Object target)
    {
        BeanUtils.copyProperties(source, target);
    }

    /**
     * 拷贝属性到新的对象
     *
     * @param sources 源对象
     * @param target  目标对象
     */
    public static <A> List<A> copyProperties(List<?> sources, Class<A> target)
    {
        List<A> targets = Lists.newArrayList(sources.size());
        for (Object source : sources) {
            A _targetInstance = ClassUtils.newInstance(target);
            copyProperties(source, _targetInstance);
            targets.add(_targetInstance);
        }

        return targets;
    }

}
