package com.beifan.foxlibc.framework.utils;

import com.beifan.foxlibc.framework.utils.io.Files;

/**
 * 虚拟机状态，启动后的状态
 *
 * @author lts
 * Create Time 2022/7/6
 */
public class JvmLauncher {

    private static final String STATE_PATH = "vm/stat";
    private static final String PID_PATH = "vm/pid";
    private static final String DONE_PATH = "vm/done";

    public static void launch(CallbackFunctionNR0 fun)
    {
        Throwable e = null;
        try {
            Files.rmkdir("vm");
            fun.apply();
            Files.makefile(STATE_PATH, "1");
            Files.makefile(PID_PATH, System.getProperty("PID"));
        } catch (Throwable throwable) {
            e = throwable;
            Files.makefile(STATE_PATH, "-1\n" + e.getMessage());
        }

        Files.makefile(DONE_PATH, "");

        if (e != null)
            throw new RuntimeException(e);
    }

}
