package com.beifan.foxlibc.framework.utils.generator;

/**
 * 验证码生成
 *
 * @author lts
 * Create time 2022/4/26
 */
public class VerifyCodes
{
    // 数字和字母的字符串数组
    private static final char[] numbersAndLetters = {
            'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
            'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
            'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
            'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
            'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
            's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
            '0', '1', '2', '3', '4', '5', '6', '7', '8', '9'
    };

    /**
     * @return 六位数带数字和字母的验证码
     */
    public static String randomComplexVerifyCode() {
        return randomComplexVerifyCode(6);
    }

    /**
     * 生成数字带字母的验证码
     * @param length 验证码长度
     */
    public static String randomComplexVerifyCode(int length)
    {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < length; i++) {
            sb.append(randomChar());
        }
        return sb.toString();
    }

    /**
     * @return 六位数纯数字的验证码
     */
    public static String randomSimpleVerifyCode() {
        return randomSimpleVerifyCode(6);
    }

    /**
     * 生成纯数字的验证码
     * @param length 验证码长度
     */
    public static String randomSimpleVerifyCode(int length)
    {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < length; i++) {
            sb.append(randomNumber());
        }
        return sb.toString();
    }

    /**
     * 生成随机字符
     */
    private static char randomChar()
    {
        int rand = (int) (Math.random() * numbersAndLetters.length);
        return numbersAndLetters[rand];
    }

    /**
     * 生成随机数字
     */
    private static int randomNumber()
    {
        return (int) (Math.random() * 10);
    }

}
