package com.beifan.foxlibc.framework.utils.io;

import com.beifan.foxlibc.framework.utils.StringUtils;

import java.io.InputStream;

/**
 * 输入流转换器
 *
 * @author lts
 * Create time 2022/4/25
 */
public class InputConverter
{
    private final InputStream _inputStream;

    public InputConverter(InputStream inputStream)
    {
        this._inputStream = inputStream;
    }

    public InputStream getInputStream()
    {
        return _inputStream;
    }

    /**
     * 把字符串拆分成行
     */
    public String[] toLines()
    {
        String text = toText();

        if (StringUtils.isEmpty(text))
            return new String[]{};

        String[] lines = text.split("\n");
        for (int i = 0; i < lines.length; i++)
            lines[i] = lines[i].trim();

        return lines;
    }

    /**
     * 将输入流转成字符串
     */
    public String toText()
    {
        byte[] buffer = new byte[1024];
        int len;
        StringBuilder sb = new StringBuilder();
        try {
            while ((len = _inputStream.read(buffer)) != -1) {
                sb.append(new String(buffer, 0, len));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return sb.toString();
    }

}
