package com.beifan.foxlibc.framework.utils.io;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Paths;

/**
 * @author lts
 * Create time 2022/4/25
 */
public class Readers
{
    private static final Class<?> _readerClass = Readers.class;

    /**
     * 获取resource目录下的文件
     */
    public static InputConverter fromPath(String path) throws IOException
    {
        return new InputConverter(Files.newInputStream(Paths.get(path)));
    }

    /**
     * 获取resource目录下的文件
     */
    public static InputConverter fromResource(String path) throws IOException
    {
        char start = path.charAt(0);
        if (start != '\\' && start != '/')
            path = "/" + path;

        InputStream input = _readerClass.getResourceAsStream(path);
        if (input == null) {
            throw new FileNotFoundException("文件不存在：" + path);
        }

        return new InputConverter(input);
    }
}
