package com.beifan.foxlibc.framework.utils.refection;

import java.lang.reflect.Constructor;

/**
 * @author lts
 * Create time 2022/4/25
 */
public class ClassUtils
{

    /**
     * 通过无参构造器实例化对象
     */
    public static <T> T newInstance(Class<T> _class)
    {
        return newInstance(_class, new Class<?>[0], new Object[0]);
    }

    /**
     * 通过构造器实例化对象
     */
    public static <T> T newInstance(Class<T> _class, Class<?>[] types, Object[] parameters)
    {
        // 获取构造器
        try {
            Constructor<T> constructor = _class.getConstructor(types);
            return constructor.newInstance(parameters);
        } catch (Exception e) {
            e.printStackTrace();
        }

        return null;
    }

}
