package com.beifan.foxlibc.framework.utils.time;

import lombok.Getter;

import java.util.Date;
import java.util.concurrent.TimeUnit;

/**
 * 时间枚举
 *
 * @author lts
 * Create time 2022/3/30
 */
public enum TimeUnits
{
    SECONDS(TimeUnit.SECONDS),
    MINUTES(TimeUnit.MINUTES),
    HOURS(TimeUnit.HOURS),
    DAYS(TimeUnit.DAYS),
    MONTHS(null),
    YEARS(null),
    ;

    @Getter
    @SuppressWarnings("FieldCanBeLocal")
    private final TimeUnit timeUnit;

    TimeUnits(TimeUnit timeUnit)
    {
        this.timeUnit = timeUnit;
    }

    /** 增加时间（默认当前时间加上传入的数字） */
    public Date add(int number)
    {
        return add(new Date(), number);
    }

    /** 增加时间 */
    public Date add(Date date, int number)
    {
        return DateUtils.plus(date, number, this);
    }

    /** 减少时间（默认当前时间减去传入的数字） */
    public Date sub(int number)
    {
        return sub(new Date(), number);
    }

    /** 减少时间 */
    public Date sub(Date date, int number)
    {
        return DateUtils.minus(date, number, this);
    }

}
