package com.beifan.foxlibc.modules.service;

import com.beifan.foxlibc.modules.pojo.model.SystemSet;
import com.beifan.foxlibc.modules.pojo.model.User;
import com.beifan.foxlibc.modules.pojo.model.UserAuth;
import com.beifan.foxlibc.modules.pojo.model.UserLogininfo;

import java.util.List;

/**
 * @author lts
 * Create Time 2022/8/4
 */
public interface UserService {

    /**
     * 获取系统设置
     */
    SystemSet systemSetting();

    /**
     * 验证appid和appSecret是否正确
     */
    boolean application(String appid, String secret);

    /**
     * 验证用户名和密码是否正确
     * @return 用户id
     */
    String sign(String username, String password);

    String idsign(String userid, String password);

    String secsign(String userId, String password);

    /**
     * 根据id查询用户
     */
    User userQuery(String userid);

    /**
     * 根据用户id查询用户权限
     */
    List<UserAuth> authQuery(String userid);

//    /**
//     * 更新用户登录状态
//     */
//    void updateUserState(String userid, String token, String sate, String validDate);
//
//    /**
//     * 更新用户密码
//     */
//    void updateUserPwd(String userid, String pwd);

    /**
     * 新增一条用户登录日志
     */
    void saveUserLogininfo(UserLogininfo userLogininfo);

    /**
     * 新增一条用户登录日志
     */
    void updateUserLogininfo(UserLogininfo userLogininfo,String oldToken);

    /**
     * 删除登录日志
     */
    void deleteUserLogininfoByToken(String token);

    /**
     * 删除登录日志
     */
    void deleteUserLogininfoByUserId(String userid);

    /**
     * 查询登录日志
     */
    UserLogininfo queryUserLogininfo(String token);

    /**
     * 查询登录日志
     */
    List<UserLogininfo> queryUserLogininfosByUserId(String userid);

    UserLogininfo queryUserLogininfosByUserIdPS(String userId);

    void updateUserPwd(String userid, String pwd);

    void updateUserSecPwd(String userid, String pwd);

    /**
     * 根据用户名查询用户
     * @param username
     * @return
     */
    User queryUserByUsername(String username);

    /**
     * 根据用户名更新失败次数
     * @param username
     * @param failCount
     */
    void updateFailCount(String username, int failCount);

    void updateStatus(String username, String status);
}
